(*
  natutil.v
  Coq version: 8.0pl1 (Jul 2004)

  Utilities for reasoning about natural numbers

  Nadeem Abdul Hamid, September 2005
*)


Require Import EqNat.
Require Import Omega.

Hint Immediate beq_nat_refl.

Lemma beq_nat_false : forall a b : nat, a <> b -> false = beq_nat a b.
Proof.
double induction a b; intros; auto; try omega.
unfold beq_nat; fold beq_nat.
auto.
Qed.

Hint Resolve beq_nat_false.


Lemma beq_nat_dec :
 forall a b : nat, { beq_nat a b = true } + { beq_nat a b = false }.
Proof.
  intros; compare a b; intros.
  rewrite e; left; auto.
  symmetry; apply beq_nat_refl.
  right; symmetry; apply beq_nat_false; auto.
Qed.
